package com.zcloud.controller.majordangersource;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.majordangersource.MonitoringDeviceSensorService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：监测设备传感器
 * 作者：luoxiaobao
 * 时间：2022-03-31
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/monitoringdevicesensor")
public class MonitoringDeviceSensorController extends BaseController {

	@Autowired
	private MonitoringDeviceSensorService monitoringdevicesensorService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions(value = {"majordangersource:add","monitoringdevice:add"}, logical = Logical.OR)
	@ResponseBody
	@LogAnno(menuType= "监测预警",menuServer= "重大危险源监测预警",instructionsOperate = "数据采集阈值设定",instructionsType = "新增")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("MONITORINGDEVICESENSOR_ID", this.get32UUID());	//主键
		pd.put("ISDELETE", "0");	//是否删除(0:有效 1：删除)
		pd.put("CREATOR", Jurisdiction.getUsername());	//添加人
		pd.put("CREATTIME", DateUtil.date2Str(new Date()));	//添加时间
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		monitoringdevicesensorService.save(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions(value = {"majordangersource:del","monitoringdevice:del"}, logical = Logical.OR)
	@ResponseBody
	@LogAnno(menuType= "监测预警",menuServer= "重大危险源监测预警",instructionsOperate = "数据采集阈值设定",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		monitoringdevicesensorService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions(value = {"majordangersource:edit","monitoringdevice:edit"}, logical = Logical.OR)
	@ResponseBody
	@LogAnno(menuType= "监测预警",menuServer= "重大危险源监测预警",instructionsOperate = "数据采集阈值设定",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		monitoringdevicesensorService.edit(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions(value = {"majordangersource:list","monitoringdevice:list"}, logical = Logical.OR)
	@ResponseBody
	@LogAnno(menuType= "监测预警",menuServer= "重大危险源监测预警",instructionsOperate = "数据采集阈值设定",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		page.setPd(pd);
		List<PageData>	varList = monitoringdevicesensorService.list(page);	//列出MonitoringDeviceSensor列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions(value = {"majordangersource:edit","monitoringdevice:edit"}, logical = Logical.OR)
	@ResponseBody
	@LogAnno(menuType= "监测预警",menuServer= "重大危险源监测预警",instructionsOperate = "数据采集阈值设定",instructionsType = "其修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		pd = monitoringdevicesensorService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions(value = {"majordangersource:del","monitoringdevice:del"}, logical = Logical.OR)
	@ResponseBody
	@LogAnno(menuType= "监测预警",menuServer= "重大危险源监测预警",instructionsOperate = "数据采集阈值设定",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String[] ArrayDATA_IDS = DATA_IDS.split(",");
			pd.put("ArrayDATA_IDS", ArrayDATA_IDS);	//待删除ids
			monitoringdevicesensorService.deleteAll(pd);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	@LogAnno(menuType= "监测预警",menuServer= "重大危险源监测预警",instructionsOperate = "数据采集阈值设定",instructionsType = "导出到excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("检测设备ID");	//1
		titles.add("检测设备传感器名称");	//2
		titles.add("检测数据类型(1.液位 2.温度)");	//3
		titles.add("量程（最小值）");	//4
		titles.add("量程（最大值）");	//5
		titles.add("一级预警（最小值）");	//6
		titles.add("一级预警（最大值）");	//7
		titles.add("二级预警（最小值）");	//8
		titles.add("二级预警（最大值）");	//9
		titles.add("三级预警（最小值）");	//10
		titles.add("三级预警（最大值）");	//11
		titles.add("四级预警（最小值）");	//12
		titles.add("四级预警（最大值）");	//13
		titles.add("是否删除(0:有效 1：删除)");	//14
		titles.add("添加人");	//15
		titles.add("添加时间");	//16
		titles.add("修改人");	//17
		titles.add("修改时间");	//18
		titles.add("企业ID");	//19
		dataMap.put("titles", titles);
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		List<PageData> varOList = monitoringdevicesensorService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("MONITORINGDEVICE_ID"));	    //1
			vpd.put("var2", varOList.get(i).getString("MONITORINGDEVICESENSOR_NAME"));	    //2
			vpd.put("var3", varOList.get(i).getString("MONITORINGDEVICESENSOR_TYPE"));	    //3
			vpd.put("var4", varOList.get(i).get("RANGE_MIN").toString());	//4
			vpd.put("var5", varOList.get(i).get("RANGE_MAX").toString());	//5
			vpd.put("var6", varOList.get(i).get("RANGE1_MIN").toString());	//6
			vpd.put("var7", varOList.get(i).get("RANGE1_MAX").toString());	//7
			vpd.put("var8", varOList.get(i).get("RANGE2_MIN").toString());	//8
			vpd.put("var9", varOList.get(i).get("RANGE2_MAX").toString());	//9
			vpd.put("var10", varOList.get(i).get("RANGE3_MIN").toString());	//10
			vpd.put("var11", varOList.get(i).get("RANGE3_MAX").toString());	//11
			vpd.put("var12", varOList.get(i).get("RANGE4_MIN").toString());	//12
			vpd.put("var13", varOList.get(i).get("RANGE4_MAX").toString());	//13
			vpd.put("var14", varOList.get(i).getString("ISDELETE"));	    //14
			vpd.put("var15", varOList.get(i).getString("CREATOR"));	    //15
			vpd.put("var16", varOList.get(i).getString("CREATTIME"));	    //16
			vpd.put("var17", varOList.get(i).getString("OPERATOR"));	    //17
			vpd.put("var18", varOList.get(i).getString("OPERATTIME"));	    //18
			vpd.put("var19", varOList.get(i).getString("CORPINFO_ID"));	    //19
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
